// Copyright (c) 2000
//      Maurice Castro (maurice@serc.rmit.edu.au)
//      All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 
// This software is provided by the original author and contributors ``as
// is'' and any express or implied warranties, including, but not limited
// to, the implied warranties of merchantability and fitness for a
// particular purpose are disclaimed.  In no event shall the authors or
// contributors be liable for any direct, indirect, incidental, special,
// exemplary, or consequential damages (including, but not limited to,
// procurement of substitute goods or services; loss of use, data, or
// profits; or business interruption) however caused and on any theory of
// liability, whether in contract, strict liability, or tort (including
// negligence or otherwise) arising in any way out of the use of this
// software, even if advised of the possibility of such damage.
//
// $Id: PageFetcher.java,v 1.2 2000/11/12 23:02:47 maurice Exp $

import java.lang.*;
import java.awt.*;
import java.net.*;
import java.util.*;

public class PageFetcher extends Thread
{
	private Vector v;

	private Thread thread;
	private TextArea status;

	public void begin(TextArea status, Vector v)
	{
		if (thread == null && v != null)
		{
			this.v = (Vector) v.clone();
			this.status = status;
			thread = new Thread(this);
			thread.start();
		}
	}

	public void end()
	{
		if (thread != null)
		{
			thread.stop();
			status.appendText("Stopped\n");
			thread = null;
		}
	}

	public void run()
	{
		status.setText("Starting ...\n");
		Enumeration pages = v.elements();
		while (pages.hasMoreElements())
		{
			GetPage page = (GetPage) pages.nextElement();
			page.Fetch();
		}
		status.appendText("Complete\n");
		thread = null;
	}
}
