// Copyright (c) 2000
//      Maurice Castro (maurice@serc.rmit.edu.au)
//      All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 
// 1. Redistributions of source code must retain the above copyright
//    notice, this list of conditions and the following disclaimer.
// 2. Redistributions in binary form must reproduce the above copyright
//    notice, this list of conditions and the following disclaimer in the
//    documentation and/or other materials provided with the distribution.
// 
// This software is provided by the original author and contributors ``as
// is'' and any express or implied warranties, including, but not limited
// to, the implied warranties of merchantability and fitness for a
// particular purpose are disclaimed.  In no event shall the authors or
// contributors be liable for any direct, indirect, incidental, special,
// exemplary, or consequential damages (including, but not limited to,
// procurement of substitute goods or services; loss of use, data, or
// profits; or business interruption) however caused and on any theory of
// liability, whether in contract, strict liability, or tort (including
// negligence or otherwise) arising in any way out of the use of this
// software, even if advised of the possibility of such damage.
//
// $Id: Proxy.java,v 1.4 2000/11/13 03:52:41 maurice Exp $

import java.awt.*;
import java.net.*;
import java.util.*;

// Apparently v1.0.2 uses proxyHost and proxyPort and later versions use
// http.proxyHost and http.proxyPort, but check the earlier variables.

class Proxy extends Dialog
{
	TextField t;
	Button s;
	Button c;

	Proxy(Frame f)
	{
		super(f, true);
		setTitle("Proxy");
		setLayout(new FlowLayout());
		add( new Label("Proxy URL"));
		t = new TextField(20);
		try 
		{
			String host = System.getProperty("proxyHost");
			int port = (new Integer(System.getProperty("proxyPort"))).intValue();
			URL proxy = new URL("http", host, port, "/");
			t.setText(proxy.toString());
		}
		catch (Exception e) {}
		add(t);
		s = new Button("Set");
		add(s);
		c = new Button("Clear");
		add(c);
		pack();
	}

	synchronized public boolean action(Event e, Object arg)
	{
		if (e.target == t || e.target == s)
		{
			try
			{
				URL proxy = new URL(t.getText());
				String host = proxy.getHost();
				int port = proxy.getPort();
				if (port != -1)
				{
					Properties p = System.getProperties();
					p.put("proxyHost", host);
					p.put("proxyPort", (new Integer(port)).toString());
					p.put("proxySet", "true");
				}
			}
			catch( Exception except ) {}
		}
		else if (e.target == c)
		{
			Properties p = System.getProperties();
			p.remove("proxyHost");
			p.remove("proxyPort");
			p.put("proxySet", "false");
		}
		notifyAll();
		dispose();
		return true;
	}
}
